#echo "helloworld";

#Locations shared with the loader program
shvar_flash_dl_done_addr="0x2007FFCC"
shvar_image_size_addr="0x2007FFC4"
shvar_flash_load_addr="0x2007FFC8"
shvar_flash_dl_addr="0x2007FFC0"
shvar_sram_load_addr="0x20020000"
shvar_spi_vendor_id="0x2007FFD0"
shvar_spi_vendor_id_done="0x2007FFD4"

run_jlink_script()
{
#	echo "run_jlink_script - $1 $2"
	script_file=$1
	opfile=$2
	$JLINKCMD -Device Cortex-M4 -If SWD -Speed 4000 -commandFile $script_file > $opfile	
}

read_vendorid()
{
	raddr=$1
	addr=$raddr
	addrv=${addr#*x}
	jlink_script_name="rmem321.jlink"
	opfile="../workFiles/vendorid.txt"
	readval=0;
	echo "mem32 $raddr 1" > $jlink_script_name
	echo "qc" >> $jlink_script_name

	run_jlink_script $jlink_script_name  $opfile

	while read line
    do
		LINES[${#LINES[@]}]="$line"
    done < "$opfile"
#	echo "">arr.txt
	count=0
	arrcount=${#LINES[@]};
#	echo "count = $count, arrcount = $arrcount" >> arr.txt
	while [ $count -lt $arrcount ] ; do
		count=$(( $count + 1 ));
		s=${LINES[$count]};
		str=${s%% =*};
#		echo "count = $count str = $str" >> arr.txt
		if [ "$str" = "$addrv" ] ; then
			readval=${s#*=}
#			echo "found required value $readval" >> arr.txt
			break;
		fi
	done
	/Bash/rm -f  $jlink_script_name  $opfile
	
	echo ${readval:3:8} > $opfile
	
}


rmem32()
{
	raddr=$1
	addr=$raddr
	addrv=${addr#*x}
	jlink_script_name="rmem32.jlink"
	opfile="opfile.txt"
	readval=0;
	echo "mem32 $raddr 1" > $jlink_script_name
	echo "qc" >> $jlink_script_name

	run_jlink_script $jlink_script_name  $opfile

	while read line
    do
		LINES[${#LINES[@]}]="$line"
    done < "$opfile"
#	echo "">arr.txt
	count=0
	arrcount=${#LINES[@]};
#	echo "count = $count, arrcount = $arrcount" >> arr.txt
	while [ $count -lt $arrcount ] ; do
		count=$(( $count + 1 ));
		s=${LINES[$count]};
		str=${s%% =*};
#		echo "count = $count str = $str" >> arr.txt
		if [ "$str" = "$addrv" ] ; then
			readval=${s#*=}
#			echo "found required value $readval" >> arr.txt
			break;
		fi
	done
	/Bash/rm -f  $jlink_script_name  $opfile
	echo $readval;
}

wmem32()
{
	waddr="$1"
	wval="$2"
#	echo $waddr $wval
	jlink_script_name="wmem32.jlink"
	opfile="opfile.txt"

	echo "w4 $waddr $wval" > $jlink_script_name
	echo "qc" >> $jlink_script_name
	
	run_jlink_script $jlink_script_name $opfile

	/Bash/rm $jlink_script_name $opfile
}

read_image()
{
	raddr="$1"
	rval="$2"

	jlink_script_name="read_image.jlink"
	opfile="opfile.txt"

	echo "w4 $shvar_image_size_addr $rval" > $jlink_script_name
	echo "w4 $shvar_flash_load_addr $raddr" >> $jlink_script_name
	echo "w4 $shvar_flash_dl_addr 0x2" >> $jlink_script_name
	echo "qc" >> $jlink_script_name
	
	run_jlink_script $jlink_script_name $opfile

	/Bash/rm $jlink_script_name $opfile
}

save_image()
{
	filename="$1"
	rval="$2"

	jlink_script_name="save_image.jlink"
	opfile="opfile.txt"

	echo "savebin \"$filename\" $shvar_sram_load_addr $rval" > $jlink_script_name
	echo "qc" >> $jlink_script_name
	
	run_jlink_script $jlink_script_name $opfile
	/Bash/rm $jlink_script_name $opfile
	return 0
}

wait_for_id_to_complete()
{
	val=0
	count=10
#	echo -n "In progress"
	while [ $val -ne "1" ] ; do
#		echo -n "."
		val=$(rmem32 $shvar_spi_vendor_id_done)
		count=$((count - 1));
		if [ $count = 0 ] ; then
			return 1;
			break;
		fi
	done
	echo ""
	if [ $val -eq "1" ] ; then 
		return 0;
	else 
		return 1;
	fi
}

wait_for_flashing_to_complete()
{
	val=0
	count=100
#	echo -n "In progress"
	while [ $val -ne "1" ] ; do
#		echo -n "."
		val=$(rmem32 $shvar_flash_dl_done_addr)
		count=$((count - 1));
		if [ $count = 0 ] ; then
			return 1;
			break;
		fi
	done
	echo ""
	if [ $val -eq "1" ] ; then 
		return 0;
	else 
		return 1;
	fi
}


# Creates & executes a Jlink Script to load a given file (program)
# into memory at the specified address & run the same.
# parameters
#	1 - file to be loaded
load_n_run()
{
	opfile="opfile.txt"
	jlink_script_name="loadfile.jlink"
	file_to_load=$1

	echo "r" > $jlink_script_name
	echo "h" >> $jlink_script_name
	echo "loadfile $file_to_load"  >> $jlink_script_name
	echo "r" >> $jlink_script_name
	echo "g" >> $jlink_script_name
	echo "qc" >> $jlink_script_name
	
	run_jlink_script $jlink_script_name $opfile
	/Bash/rm $jlink_script_name $opfile	
}

# Create & executes a Jlink Script to flash the image given & run it
# parameters
#	1 - Name of the Image file
#	2 - Size of the Image Partition
#	3 - Location in flash, where this image has to be written
flash_image()
{
	image_name=$1
	image_size=$2
	flash_load_address=$3
	jlink_script_name=flash_image.jlink
	opfile="opfile.txt"

	echo "loadfile \"$image_name\",$shvar_sram_load_addr"  > $jlink_script_name
	echo "w4 $shvar_image_size_addr $image_size" >> $jlink_script_name
	echo "w4 $shvar_flash_load_addr $flash_load_address" >> $jlink_script_name
	echo "w4 $shvar_flash_dl_addr 0x1" >> $jlink_script_name
	echo "qc" >> $jlink_script_name

	run_jlink_script $jlink_script_name $opfile
	/Bash/rm $jlink_script_name $opfile	
}

# IMAGE_NAME="EOSS3B_BL0.bin"
# IMAGE_SIZE="0x8000"
# IMAGE_FLASH_ADDR="0x0"

check_n_exit()
{
	if [ -z "$1" ] ; then
	echo "$2"
	exit -1;
	fi
}

IMAGE_NAME="$1"
IMAGE_SIZE="$2"
IMAGE_FLASH_ADDR="$3"
IMAGE_VERIFY="$4"

IMAGE_FLASHER_NAME="ipl.bin"

check_n_exit "$IMAGE_NAME" "Image to be flashed not given"
check_n_exit "$IMAGE_SIZE" "Image size not given"
check_n_exit "$IMAGE_FLASH_ADDR" "Addres where image to be written to flash not given"
check_n_exit "$JLINKCMD" "Jlink command location not set"

if [ ! -f $IMAGE_FLASHER_NAME ] ; then
	echo "Unable to find Image flasher";
	exit -1;
fi

if [ "$IMAGE_NAME" == "VendorId" ] ; then
	load_n_run $IMAGE_FLASHER_NAME;
	read_vendorid $shvar_spi_vendor_id;
	wait_for_id_to_complete;
	flash_success=$?
	exit $flash_success; 
fi

if [ ! -f $IMAGE_NAME ] ; then
	echo "Unable to find file $IMAGE_NAME";
	exit -1;
fi

echo "########################################"
echo "Writing $IMAGE_NAME of size $IMAGE_SIZE to $IMAGE_FLASH_ADDR"
load_n_run $IMAGE_FLASHER_NAME;
flash_image "$IMAGE_NAME" $IMAGE_SIZE $IMAGE_FLASH_ADDR;
wait_for_flashing_to_complete;
flash_success=$?
if [ "$flash_success" -ne "0" ] ; then 
	echo "Flashing $IMAGE_NAME failed."
	echo "Flashing NOT SUCCESS."
	exit $flash_success; 
fi

#echo "Verify: $IMAGE_VERIFY"
if [ "$IMAGE_VERIFY" == "TRUE" ] ; then 
	IMAGE_NAME_VERIFY="$IMAGE_NAME.tmp"
	echo "########################################"
	echo "Reading $IMAGE_NAME of size $IMAGE_SIZE to $IMAGE_FLASH_ADDR"
	load_n_run $IMAGE_FLASHER_NAME;
	read_image $IMAGE_FLASH_ADDR $IMAGE_SIZE;
	wait_for_flashing_to_complete;
	flash_success=$?
	if [ "$flash_success" -ne "0" ] ; then 
		echo "Reading $IMAGE_NAME failed."
		echo "Flashing NOT SUCCESS."
		exit $flash_success; 
	fi
	
	save_image "$IMAGE_NAME_VERIFY" $IMAGE_SIZE;
	echo "reading completed.................."
	#echo "diff $IMAGE_NAME $IMAGE_NAME_VERIFY"
	/Bash/diff "$IMAGE_NAME" "$IMAGE_NAME_VERIFY"
	flash_success=$?
	/Bash/rm -f "$IMAGE_NAME_VERIFY"
	if [ "$flash_success" -ne "0" ] ; then 
		echo "Verifying $IMAGE_NAME failed."
		echo "Verifying NOT SUCCESS. Flashing failed"
	else
		echo "Flashing $IMAGE_NAME done."
		#echo "Image Flashing and Verify SUCCESS."
		echo "Image Flashing SUCCESS."
	fi
else
	echo "Flashing $IMAGE_NAME done."
	echo "Image Flashing SUCCESS."
fi

exit $flash_success;